﻿if select(2, UnitClass("player")) ~= "PALADIN" then return end

local SpellName, _, SpellIcon = GetSpellInfo(88819) -- Daybreak

local extraOptions = {
 {
  [0] = "Additional",
  { type = "Check", var = "colGradientTime", default = true, label = "Use Gradient Color for Time", tip = "", y = 12 },
  { type = "Check", var = "colGradient", default = true, label = "Use Gradient Color for Bar", tip = "", y = 8 },
  { type = "Color", var = "colNormal", default = { 0.4, 0.6, 0.8, 1.0 }, label = "Bar Color", y = 8 },
  { type = "Check", var = "AbilityName", default = true, label = "Use Ability Name", tip = "", y = 12 },
 },
}
local bcr, bcg, bcb = 0.4, 0.6, 0.8
local tcr, tcg, tcb = 0, 1, 0
local useGradient, useGradientTime, useAbilityName = true, true, true

local select = select
-- http://www.wowwiki.com/ColorGradient
local function ColorGradient(perc, ...)
 if perc >= 1 then
  local r, g, b = select(select('#', ...) - 2, ...)
  return r, g, b
 elseif perc <= 0 then
  local r, g, b = ...
  return r, g, b
 end
 local num = select('#', ...) / 3
 local segment, relperc = math.modf(perc*(num-1))
 local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, ...)
 return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end

local sformat = string.format

-- Plugin
local plugin = AzCastBar.CreateMainBar("Frame", "Daybreak", extraOptions)

-- Init Bar
plugin.icon:SetTexture(SpellIcon)
plugin.name:SetText(SpellName)
plugin:SetPoint("CENTER", -50)
plugin.status:SetMinMaxValues(0, 10)
plugin.status:SetValue(0)
plugin.timeleft = 0
plugin.duration = 10

-------------------------------------------------------------------------------
-- Code
-------------------------------------------------------------------------------
function plugin:OnConfigChanged(cfg)
 bcr, bcg, bcb = unpack(cfg.colNormal)
 tcr, tcg, tcb = unpack(cfg.colTimeLabel)
 useGradient = cfg.colGradient
 if not useGradient then
  self.status:SetStatusBarColor(bcr, bcg, bcb, 1)
 end
 useGradientTime = cfg.colGradientTime
 if not useGradientTime then
  self.time:SetTextColor(tcr, tcg, tcb, 1)
 end
 useAbilityName = cfg.AbilityName
 if cfg.enabled then
  self:RegisterEvent("UNIT_AURA")
 else
  self:UnregisterAllEvents()
  self:Hide()
 end
end

plugin:SetScript("OnUpdate", function(self, elapsed)
 self.timeleft = self.timeleft - elapsed
 if self.timeleft > 0 then
  self.status:SetValue(self.timeleft)
  self.time:SetFormattedText("%d", ceil(self.timeleft))
  local percent = self.timeleft/self.duration
  local cr, cg, cb
  if useGradient then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, bcr, bcg, bcb)
   self.status:SetStatusBarColor(cr, cg, cb, 1)
  end
  if useGradientTime then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, tcr, tcg, tcb)
   self.time:SetTextColor(cr, cg, cb, 1)
  end
 else
  self:Hide()
 end
end)

plugin:SetScript("OnEvent", function(self, event, unit)
 if unit == "player" then
  local count, duration, timeLeft, caster, spellid
  local index = 1
  while true do
   count, _, duration, timeLeft, caster, _, _, spellid = select(4, UnitBuff("player", index, "PLAYER"))
   if not spellid then
    if self:IsShown() then
     self:Hide()
    end
    break
   elseif spellid == 88819 and caster then
    if self.duration ~= duration then
     self.status:SetMinMaxValues(0, duration)
     self.duration = duration
    end
    self.name:SetFormattedText("%d%s", count, useAbilityName and sformat(" | %s", SpellName) or "")
    self.timeleft = timeLeft - GetTime()
    if not self:IsShown() then
     self:Show()
    end
    break
   end
   index = index + 1
  end
 end
end)
