﻿if select(2, UnitClass("player")) ~= "PALADIN" then return end

local extraOptions = {
 {
  [0] = "Additional",
  { type = "Color", var = "colBar4", default = { 1, 1, 0, 1 }, label = "Charge 1 Color", tip = "", y = 6 }, -- жёлтый
  { type = "Color", var = "colBar1", default = { 0, 1, 0, 1 }, label = "Charge 2 (or 1) Color", tip = "", y = 6 }, -- зелёный
  { type = "Color", var = "colBar2", default = { 0, 1, 1, 1 }, label = "Charge 3 (or 2) Color", tip = "", y = 6 }, -- голубой
  { type = "Color", var = "colBar5", default = { 1, 0, 1, 1 }, label = "Charge 4 Color", tip = "", y = 6 }, -- розовый
  { type = "Color", var = "colBar3", default = { 1, 0, 0, 1 }, label = "Charge 5 (or 3) Color", tip = "", y = 10 }, -- красный
  { type = "Check", var = "DivinePurpose", default = false, label = "Use Divine Purpose", tip = "", y = 10 },
  { type = "Check", var = "FiveBar", default = false, label = "Use five charges bar", tip = "", y = 10 },
 },
}

local ChargesColor = {
 [1] = {1, 1, 0, 1}, -- жёлтый
 [2] = {0, 1, 0, 1}, -- зелёный
 [3] = {0, 1, 1, 1}, -- голубой
 [4] = {1, 0, 1, 1}, -- розовый
 [5] = {1, 0, 0, 1}  -- красный
}

local DivinePurpose
local useFiveBar = 3
local select = select

-- Plugin
local plugin = AzCastBar.CreateMainBar("Frame", "HolyPower", extraOptions)

-- Init Bar
plugin.icon:SetTexture(select(3, GetSpellInfo(85673)))
plugin.name:SetText("Holy Power")
plugin:SetPoint("CENTER", -50)
plugin.status:SetMinMaxValues(0, 3)
plugin.status:SetValue(0)

-------------------------------------------------------------------------------
-- Code
-------------------------------------------------------------------------------
local SPELL_POWER_HOLY_POWER = SPELL_POWER_HOLY_POWER
local function CheckHolyPower(self)
 local power = UnitPower("player", SPELL_POWER_HOLY_POWER)
 self.time:SetFormattedText("%d", power)
 power = (DivinePurpose or power > useFiveBar) and useFiveBar or power
 self.status:SetValue(power)
 if power == 0 then
  if self:IsShown() then
   self:Hide()
  end
 else
  self.status:SetStatusBarColor(unpack(ChargesColor[power]))
  if not self:IsShown() then
   self:Show()
  end
 end
end

function plugin:OnConfigChanged(cfg)
 ChargesColor[1] = cfg.FiveBar and cfg.colBar4 or cfg.colBar1
 ChargesColor[2] = cfg.FiveBar and cfg.colBar1 or cfg.colBar2
 ChargesColor[3] = cfg.FiveBar and cfg.colBar2 or cfg.colBar3
 ChargesColor[4] = cfg.colBar5
 ChargesColor[5] = cfg.colBar3
 useFiveBar = cfg.FiveBar and 5 or 3
 self.status:SetMinMaxValues(0, useFiveBar)
 if cfg.enabled then
  self:RegisterEvent("UNIT_POWER")
  if cfg.DivinePurpose then
   self:RegisterEvent("UNIT_AURA")
  elseif self:IsEventRegistered("UNIT_AURA") then
   DivinePurpose = false
   self:UnregisterEvent("UNIT_AURA")
  end
  CheckHolyPower(self)
 else
  self:UnregisterAllEvents()
  DivinePurpose = false
  self:Hide()
 end
end

plugin:SetScript("OnEvent", function(self, event, unit, powerType)
 if unit == "player" then
  if event == "UNIT_POWER" and powerType == "HOLY_POWER" then
   CheckHolyPower(self)
  elseif event == "UNIT_AURA" then
   local spellid
   local index = 1
   while true do
    spellid = select(11, UnitBuff("player", index, "PLAYER"))
    if not spellid then
     DivinePurpose = false
     break
    elseif spellid == 90174 then
     DivinePurpose = true
     break
    end
    index = index + 1
   end
   if (DivinePurpose and self.status:GetValue() ~= useFiveBar) or (not DivinePurpose and self.status:GetValue() == useFiveBar) then
    CheckHolyPower(self)
   end
  end
 end
end)
