﻿if select(2, UnitClass("player")) ~= "PALADIN" then return end

local Removed = GetLocale() == "ruRU" and "рассеивается!" or "was removed!"

local SpellName, _, SpellIcon = GetSpellInfo(53563) -- Частица света

local extraOptions = {
 {
  [0] = "Additional",
  { type = "Color", var = "colNormal", default = { 0.4, 0.6, 0.8, 1.0 }, label = "Bar Color", y = 12 },
  { type = "Check", var = "colClassColor", default = true, label = "Use Class Color", tip = "", y = 12 },
  { type = "Check", var = "AbilityName", default = false, label = "Use Ability Name", tip = "", y = 12 },
 },
}
local useClassColor, useAbilityName = true, false

local RAID_CLASS_COLORS = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS
local sformat = string.format
local function ColorClass(name)
 local c = RAID_CLASS_COLORS[select(2, UnitClass(name)) or "PRIEST"]
 return sformat("|c%s%s|r", c.colorStr, name)
end

-- Plugin
local plugin = AzCastBar.CreateMainBar("Frame", "Beacon", extraOptions)

-- Init Bar
plugin.icon:SetTexture(SpellIcon)
plugin.name:SetText(SpellName)
plugin.name:SetJustifyV("CENTER")
plugin:SetPoint("CENTER", -50)
plugin.status:SetMinMaxValues(0, 1)
plugin.status:SetValue(1)
plugin.time:SetText("☼")
plugin.guid = nil

-------------------------------------------------------------------------------
-- Code
-------------------------------------------------------------------------------
local function AddBeacon(self, guid, name)
 self.guid = guid
 self.name:SetFormattedText("%s%s", useClassColor and ColorClass(name) or name, useAbilityName and sformat(" (%s)", SpellName) or "")
 self:Show()
end

local function RemoveBeacon(self, name)
 if name then
  PlaySound("RaidWarning")
  RaidNotice_AddMessage(RaidWarningFrame, sformat("%s -> %s %s", GetSpellLink(53563), name, Removed), ChatTypeInfo["RAID_WARNING"], 8)
 end
 self.guid = nil
 self:Hide()
end

local function IsBeaconed(unit)
 local caster, spellid
 local index = 1
 while true do
  caster, _, _, spellid = select(8, UnitBuff(unit, index, "PLAYER"))
  if not spellid then
   break
  elseif spellid == 53563 and caster then
   return true
  end
  index = index + 1
 end
 return false
end

local function CheckBeacon(self)
 local i, unit, tempunit
 if IsInRaid() then
  for i = 1, GetNumGroupMembers() do
   tempunit = "raid"..i
   if IsBeaconed(tempunit) then
    unit = tempunit
    break
   end
  end
 else
  if IsInGroup() then
   for i = 1, GetNumSubgroupMembers() do
    tempunit = "party"..i
    if IsBeaconed(tempunit) then
     unit = tempunit
     break
    end
   end
  end
  if not unit and IsBeaconed("player") then
   unit = "player"
  end
 end
 if unit then
  AddBeacon(self, UnitGUID(unit), UnitName(unit))
 elseif self:IsShown() then
  RemoveBeacon(self)
 end
end

function plugin:OnConfigChanged(cfg)
 self.status:SetStatusBarColor(unpack(cfg.colNormal))
 useClassColor = cfg.colClassColor
 useAbilityName = cfg.AbilityName
 if cfg.enabled then
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("GROUP_ROSTER_UPDATE")
  self:RegisterEvent("GROUP_JOINED")
  self:RegisterEvent("PLAYER_ENTERING_WORLD")
  CheckBeacon(self)
 else
  self:UnregisterAllEvents()
  self:Hide()
 end
end

plugin:SetScript("OnEvent", function(self, event, ...)
 if event == "COMBAT_LOG_EVENT_UNFILTERED" then
  local _, eventType, _, srcGUID, _, _, _, dstGUID, dstName, _, _, spellID, spellName = ...
  if spellID == 53563 and srcGUID == UnitGUID("player") then
   if eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
    AddBeacon(self, dstGUID, dstName)
   elseif eventType == "SPELL_AURA_REMOVED" and dstGUID == self.guid then
    RemoveBeacon(self, dstName)
   end
  end
 elseif ((event == "GROUP_ROSTER_UPDATE" or event == "GROUP_JOINED") and self:IsShown() and tonumber(self.guid:sub(5, 5), 16) % 8 == 0) or event == "PLAYER_ENTERING_WORLD" then
  CheckBeacon(self)
 end
end)
