﻿if select(2, UnitClass("player")) ~= "PALADIN" then return end

local LCI = LibStub("libCandyIcon-2.0", true)

local SpellName, _, SpellIcon = GetSpellInfo(85804) -- Selfless Healer
local SelflessHealer, IAmHealer

local extraOptions = {
 {
  [0] = "Additional",
  { type = "Check", var = "colGradientTime", default = true, label = "Use Gradient Color for Time", tip = "", y = 12 },
  { type = "Check", var = "colGradient", default = true, label = "Use Gradient Color for Bar", tip = "", y = 8 },
  { type = "Color", var = "colNormal", default = { 0.4, 0.6, 0.8, 1.0 }, label = "Bar Color", y = 8 },
  { type = "Check", var = "colClassColor", default = true, label = "Use Class Color", tip = "", y = 12 },
  { type = "Check", var = "AbilityName", default = false, label = "Use Ability Name", tip = "", y = 12 },
  { type = "Check", var = "LastTarget", default = false, label = "Last Target for Eternal Flame/Sacred Shield", tip = "Used only in holy spec", y = 14 },
 },
 {
  [0] = "Animation",
  { type = "Check", var = "Animation", default = true, label = "Enable Animation", tip = "", y = 12 },
  { type = "Slider", var = "AnimationTime", default = 4, label = "Animation time", min = 1, max = 29, step = 1, y = 4 },
  { type = "Slider", var = "AnimationX", default = 354, label = "Animation Icon Offset X", min = 0, max = 2048, step = 1, y = 4 },
  { type = "Slider", var = "AnimationY", default = 546, label = "Animation Icon Offset Y", min = 0, max = 1536, step = 1, y = 4 },
  { type = "Slider", var = "AnimationSize", default = 60, label = "Animation Icon Size", min = 20, max = 200, step = 1, y = 16 },
  { type = "Check", var = "AnimationLock", default = true, label = "Lock/Unlock", tip = "" },
 },
}
local bcr, bcg, bcb = 0.4, 0.6, 0.8
local tcr, tcg, tcb = 0, 1, 0
local useGradient, useGradientTime, useClassColor, useAbilityName, useLastTarget = true, true, true, false, false
local useAnimation, useLocked, animationTime = true, true, 4
local Blocked = false
local AbilityName

local SSArray = {}

local select = select
-- http://www.wowwiki.com/ColorGradient
local function ColorGradient(perc, ...)
 if perc >= 1 then
  local r, g, b = select(select('#', ...) - 2, ...)
  return r, g, b
 elseif perc <= 0 then
  local r, g, b = ...
  return r, g, b
 end
 local num = select('#', ...) / 3
 local segment, relperc = math.modf(perc*(num-1))
 local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, ...)
 return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end

local RAID_CLASS_COLORS = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS
local sformat = string.format
local function ColorClass(name)
 local c = RAID_CLASS_COLORS[select(2, UnitClass(name)) or "PRIEST"]
 return sformat("|c%s%s|r", c.colorStr, name)
end

local button = CreateFrame("Frame", "_"..SpellName.."_", UIParent)
button:Hide()
button:SetScale(1)
button:SetClampedToScreen(true)

local icon = button:CreateTexture(nil, "BACKGROUND")
icon:SetTexCoord(0.07,0.93,0.07,0.93)
icon:SetAllPoints(button)
icon:SetVertexColor(1.0, 0.6, 0.3, 1)
icon:SetTexture(SpellIcon)
icon:SetVertexColor(1, 1, 1, 1)
icon:SetBlendMode("DISABLE")

button.icon = icon

if LCI then
 local animation = {
  ["alpha"] = 1.0,
  ["fadein_anim"] = "id",
  ["fadein_duration"] = 0.2,
  ["fadeout_anim"] = "magnify",
  ["fadeout_duration"] = 0.2,
  ["idle_anim"] = "bounce",
  ["idle_duration"] = 1.0,
 }

 LCI:MakeCandyIcon(button, animation)

 button.RealShow = button.Show

 button.Show = function(self)
  self:RealShow()
  self:Play()
 end

 button.Hide = function(self)
  self:Stop()
 end
end

-- Plugin
local plugin = AzCastBar.CreateMainBar("Frame", "Selfless", extraOptions)

-- Init Bar
plugin.icon:SetTexture(SpellIcon)
plugin.name:SetText(SpellName)
plugin:SetPoint("CENTER", -50)
plugin.status:SetMinMaxValues(0, 15)
plugin.status:SetValue(0)
plugin.timeleft = 0
plugin.duration = 15
plugin.guid = nil
plugin.beacon = nil

-------------------------------------------------------------------------------
-- Code
-------------------------------------------------------------------------------
local function CheckTalents(self)
 IAmHealer = GetSpecialization() == 1
 local Tier3 = SelflessHealer
 SelflessHealer = select(5, GetTalentInfo(7)) and 85804 or (select(5, GetTalentInfo(8)) and 114163 or (select(5, GetTalentInfo(9)) and (IAmHealer and 148039 or 20925)))
 if SelflessHealer then
  if SelflessHealer ~= Tier3 then
   if self:IsShown() then
    table.wipe(SSArray)
    self.timeleft = 0
   end
   Tier3 = select(3, GetSpellInfo(SelflessHealer))
   self.icon:SetTexture(Tier3)
   button.icon:SetTexture(Tier3)
  end
 elseif self:IsShown() then
  table.wipe(SSArray)
  self.timeleft = 0
 end
end

local function IsBeaconed(unit)
 local caster, spellid
 local index = 1
 while true do
  caster, _, _, spellid = select(8, UnitBuff(unit, index, "PLAYER"))
  if not spellid then
   break
  elseif spellid == 53563 and caster then
   return true
  end
  index = index + 1
 end
 return false
end

local function CheckBeacon(self)
 local i, unit, tempunit
 if IsInRaid() then
  for i = 1, GetNumGroupMembers() do
   tempunit = "raid"..i
   if IsBeaconed(tempunit) then
    unit = tempunit
    break
   end
  end
 else
  if IsInGroup() then
   for i = 1, GetNumSubgroupMembers() do
    tempunit = "party"..i
    if IsBeaconed(tempunit) then
     unit = tempunit
     break
    end
   end
  end
  if not unit and IsBeaconed("player") then
   unit = "player"
  end
 end
 self.beacon = unit and UnitGUID(unit) or nil
end

local function CheckTime(dstGUID, spellID)
 local WhatID = (dstGUID == UnitGUID("player")) and "player" or ((dstGUID == UnitGUID("target")) and "target" or ((dstGUID == UnitGUID("focus")) and "focus" or ((dstGUID == UnitGUID("mouseover")) and "mouseover" or nil)))
 if WhatID then
  local timeleft, caster, spellid
  local index = 1
  while UnitGUID(WhatID) == dstGUID do
   timeleft, caster, _, _, spellid = select(7, UnitBuff(WhatID, index, "PLAYER"))
   if not spellid then
    break
   elseif spellid == spellID and caster then
    return timeleft
   end
   index = index + 1
  end
 end
 return GetTime() + 30
end

local function SearchGUID(dstGUID)
 for num, entry in pairs(SSArray) do
  if entry.GUID == dstGUID then return num end
 end
 return nil
end

local function SetPlugin(self, dstGUID, dstName, duration, ext)
 if ext and self.duration ~= duration then                   
  self.status:SetMinMaxValues(0, duration)
  self.duration = duration
 end
 self.guid = dstGUID
 self.name:SetFormattedText("%s%s%s", #SSArray ~= 0 and sformat("%d | ", #SSArray) or "", useClassColor and ColorClass(dstName) or dstName, useAbilityName and sformat(" (%s)", AbilityName) or "")
 self.timeleft = duration
 if not self:IsShown() then
  self:Show()
 end
end

function plugin:OnConfigChanged(cfg)
 bcr, bcg, bcb = unpack(cfg.colNormal)
 tcr, tcg, tcb = unpack(cfg.colTimeLabel)
 useGradient = cfg.colGradient
 if not useGradient then
  self.status:SetStatusBarColor(bcr, bcg, bcb, 1)
 end
 useGradientTime = cfg.colGradientTime
 if not useGradientTime then
  self.time:SetTextColor(tcr, tcg, tcb, 1)
 end
 useClassColor = cfg.colClassColor
 useAbilityName = cfg.AbilityName
 useLastTarget = cfg.LastTarget
 if useLastTarget then
  table.wipe(SSArray)
 end
 useAnimation = cfg.Animation
 useLocked = cfg.AnimationLock
 animationTime = cfg.AnimationTime
 if useLocked then
  button:Hide()
 else
  button:Show()
 end
 button:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", cfg.AnimationX, cfg.AnimationY)
 button:SetSize(cfg.AnimationSize, cfg.AnimationSize)
 if cfg.enabled then
  self.InCombat = UnitAffectingCombat("player")
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("UNIT_AURA")
  self:RegisterEvent("GROUP_ROSTER_UPDATE")
  self:RegisterEvent("GROUP_JOINED")
  self:RegisterEvent("PLAYER_ENTERING_WORLD")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
  CheckBeacon(self)
 else
  self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:UnregisterEvent("UNIT_AURA")
  self:UnregisterEvent("GROUP_ROSTER_UPDATE")
  self:UnregisterEvent("GROUP_JOINED")
  self:UnregisterEvent("PLAYER_ENTERING_WORLD")
  self:UnregisterEvent("PLAYER_REGEN_DISABLED")
  self:UnregisterEvent("PLAYER_REGEN_ENABLED")
  table.wipe(SSArray)
  self.timeleft = 0
 end
end

plugin:SetScript("OnUpdate", function(self, elapsed)
 self.timeleft = self.timeleft - elapsed
 if self.timeleft > 0 then
  self.status:SetValue(self.timeleft)
  self.time:SetFormattedText("%d", ceil(self.timeleft))
  local percent = self.timeleft/self.duration
  local cr, cg, cb
  if useGradient then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, bcr, bcg, bcb)
   self.status:SetStatusBarColor(cr, cg, cb, 1)
  end
  if useGradientTime then
   cr, cg, cb = ColorGradient(percent, 1, 0, 0, tcr, tcg, tcb)
   self.time:SetTextColor(cr, cg, cb, 1)
  end
  if self.timeleft < animationTime and self.InCombat and useAnimation then
   if not button:IsShown() then
    button:Show()
   end
  elseif useLocked and button:IsShown() then
   button:Hide()
  end
 elseif not Blocked then
  if #SSArray ~= 0 and SSArray[1].GUID == self.guid then
   table.remove(SSArray, 1)
   if #SSArray ~= 0 then
    SetPlugin(self, SSArray[1].GUID, SSArray[1].Name, SSArray[1].EndTime - GetTime(), true)
    if self.timeleft < 0 then
     self.timeleft = 0
    end
   end
  end
  if self.timeleft < 0 then
   self.guid = nil
   if useLocked and button:IsShown() then
    button:Hide()
   end
   self:Hide()
  end
 end
end)

plugin:SetScript("OnEvent", function(self, event, unit, ...)
 if event == "COMBAT_LOG_EVENT_UNFILTERED" then
  local eventType, _, srcGUID, _, _, _, dstGUID, dstName, _, _, spellID, spellName = ...
  if srcGUID == UnitGUID("player") then
   if eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
    if (spellID == 20925 or (spellID == 148039 and useLastTarget) or (spellID == 114163 and (not IAmHealer or (useLastTarget or dstGUID == self.beacon)))) then -- Sacred Shield или Eternal Flame
     AbilityName = spellName
     SetPlugin(self, dstGUID, dstName, CheckTime(dstGUID, spellID) - GetTime(), true)
    elseif spellID == 148039 then -- Sacred Shield (Holy)
     Blocked = true
     AbilityName = spellName
     local num = SearchGUID(dstGUID)
     if num then
      table.remove(SSArray, num)
     end
     table.insert(SSArray, {GUID = dstGUID, Name = dstName, EndTime = CheckTime(dstGUID, spellID)})
     SetPlugin(self, SSArray[1].GUID, SSArray[1].Name, SSArray[1].EndTime - GetTime(), SSArray[1].GUID ~= self.guid or #SSArray == 1)
     Blocked = false
    elseif spellID == 53563 then
     self.beacon = dstGUID
    end
   elseif eventType == "SPELL_AURA_REMOVED" then
    if (spellID == 20925 or (spellID == 148039 and useLastTarget) or (spellID == 114163 and (not IAmHealer or (useLastTarget or (not self.beacon or dstGUID == self.beacon))))) and dstGUID == self.guid then -- Sacred Shield или Eternal Flame
     self.timeleft = 0
    elseif spellID == 148039 then -- Sacred Shield (Holy)
     Blocked = true
     local num = SearchGUID(dstGUID)
     if num then
      if dstGUID == self.guid then
       self.timeleft = 0
      else
       table.remove(SSArray, num)
       self.name:SetFormattedText("%d | %s%s", #SSArray, useClassColor and ColorClass(SSArray[1].Name) or SSArray[1].Name, useAbilityName and sformat(" (%s)", AbilityName) or "")
      end
     end
     Blocked = false
    elseif spellID == 53563 and dstGUID == self.beacon then
     self.beacon = nil
    end
   end
  end
 elseif event == "UNIT_AURA" and unit == "player" and SelflessHealer == 85804 then
  local count, duration, timeleft, caster, spellid
  local index = 1
  while true do
   count, _, duration, timeleft, caster, _, _, spellid = select(4, UnitBuff("player", index, "PLAYER"))
   if not spellid then
    if self:IsShown() then
     self.timeleft = 0
    end
    break
   elseif spellid == 114250 and caster then
    if self.duration ~= duration then
     self.status:SetMinMaxValues(0, duration)
     self.duration = duration
    end
    self.name:SetFormattedText(">> %d <<%s", count, useAbilityName and sformat(" (%s)", SpellName) or "")
    self.timeleft = timeleft - GetTime()
    if not self:IsShown() then
     self:Show()
    end
    break
   end
   index = index + 1
  end
 elseif ((event == "GROUP_ROSTER_UPDATE" or event == "GROUP_JOINED") and self.beacon and tonumber(self.beacon:sub(5, 5), 16) % 8 == 0) or event == "PLAYER_ENTERING_WORLD" then
  CheckBeacon(self)
 elseif event == "PLAYER_REGEN_DISABLED" then
  self.InCombat = true
 elseif event == "PLAYER_REGEN_ENABLED" then
  self.InCombat = false
 elseif event == "PLAYER_TALENT_UPDATE" then
  CheckTalents(self)
 elseif event == "SKILL_LINES_CHANGED" then
  self.InCombat = UnitAffectingCombat("player")
  CheckTalents(self)
  self:RegisterEvent("PLAYER_TALENT_UPDATE")
  self:UnregisterEvent(event)
 end
end)

plugin:RegisterEvent("SKILL_LINES_CHANGED")
